@Filename: AdcTst.s
@Part: ADuC702x.
@Created: 15/04/2004
@Updated: 28/06/2005
@Author: Eckart Hartmann.
@This file is in beta sampling.

.include        "ADuC7020.equ"
.ARM


@ AdcTst==========Start ADC test.
@ C Function prototype: int AdcTst(void);
@ Description of Function: Start ADC test.
@   Call AdcGo to start converting with these settings.
@ Robustness:  The first conversion result after the ADC had been powered
@               down (ADC_OFF) is not accurate.
@ Side effects: Corrupts r3 and r1.
@               Terminates any conversion that might be running.

.GLOBAL AdcTst
AdcTst: 
        mov     r3,#0xff0000            @r3 = Z_BASE;
        orr     r3,r3,#0xff000000
        mov     r0,#0                   @ChannelP 0;
        str     r0,[r3,#ADCCP_OFFSET]
        mov     r0,#1                   @ChannelN 1;
        str     r0,[r3,#ADCCN_OFFSET]
        mov     r1,#0xa3                @Start single ended.
        str     r1,[r3,#ADCCON_OFFSET]
lp1:    ldr     r1,[r3,#ADCSTA_OFFSET]  @while(converting);
        tst     r1,#1
        beq     lp1                     @ADCDAT ~= 0x09990000.
        mov     r1,#0xab                @Start differential.
        str     r1,[r3,#ADCCON_OFFSET]
lp2:    ldr     r1,[r3,#ADCSTA_OFFSET]  @while(converting);
        tst     r1,#1
        beq     lp2                     @ADCDAT ~= 0x06660000.
        mov     r0,#1                   @ChannelP 1;
        str     r0,[r3,#ADCCP_OFFSET]
        mov     r0,#0                   @ChannelN 0;
        str     r0,[r3,#ADCCN_OFFSET]
        mov     r1,#0xab                @Start differential.
        str     r1,[r3,#ADCCON_OFFSET]
lp3:    ldr     r1,[r3,#ADCSTA_OFFSET]  @while(converting);
        tst     r1,#1
        beq     lp3                     @ADCDAT ~= 0xf9990000.
here:   b       here
